<?php
defined( 'ABSPATH' ) OR exit;
/*
	Plugin Name: Yourstyle + Social Buttons
	Plugin URI: http://your-style.nl/
	Description: Adds Social Media Buttons to your Yourstyle+ site.
	Author: Yourstyle
	Author URI: http://your-style.nl/
	Version: 2.1.1
	License: GPLv2
	Text Domain: ysdb-socialbtns
*/

__('Yourstyle + Social Buttons', 'ysdb-socialbtns');
__('Adds Social Media Buttons to your Yourstyle+ site.','ysdb-socialbtns');

register_uninstall_hook(__FILE__, array( 'ysdb-socialbtns', 'plugin_uninstall' ));

/* BASIC PLUGIN STUFF */
class wpysdbsocialbtns {

	function __construct() {
		// Register Textdomain
        load_plugin_textdomain('ysdb-socialbtns', false, dirname( plugin_basename( __FILE__ ) ) . '/languages/'); //Translation Support
        
        // Register Options
        add_action('admin_init', array($this, 'register_options'));

        // Register Settings Menu
        add_action('admin_menu', array($this, 'register_admin_menus'), 99999);
	}

    // Register Options
    public function register_options() {
        register_setting('ysp-social-media-buttons', 'ysp-smb-button-1-type');
        add_option('ysp-smb-button-1-type', 'twitter');

        register_setting('ysp-social-media-buttons', 'ysp-smb-button-2-type');
        add_option('ysp-smb-button-2-type', 'facebook');

        register_setting('ysp-social-media-buttons', 'ysp-smb-button-3-type');
        add_option('ysp-smb-button-3-type', 'linkedin');

        register_setting('ysp-social-media-buttons', 'ysp-smb-button-4-type');
        add_option('ysp-smb-button-4-type', 'email');

        register_setting('ysp-social-media-buttons', 'ysp-smb-button-5-type');
        add_option('ysp-smb-button-5-type', 'whatsapp');
    }

    // Register Settings Menu
    public function register_admin_menus() {
        add_submenu_page(
            'ysp-dashboard',
            __('Social Media Buttons', 'ysdb-socialbtns'),
            __('Social Media Buttons', 'ysdb-socialbtns'),
            'manage_options',
            'ysp-social-media-buttons',
            array($this, 'render_settings_page')
        );        
    }

    // The settings page
    public function render_settings_page() {
        // Add Styles
        echo '
        <style>
            .form-table input, .form-table .sub-label { display:inline-block; min-width: 100px; }
        </style>';

        //Draw Settings Page Head
        echo '
        <div class="wrap">
            <h1 class="wp-heading-inline">'.__('Social Media Buttons', 'ysdb-socialbtns').'</h1>
            <hr class="wp-header-end">';

        // Save Settings on POST
        if (!empty($_POST)) {
            echo '<div id="message" class="updated"><p><strong>'.__('Settings saved.').'</strong></p></div>';
            foreach ($_POST as $key => $value) {
                update_option($key, $value);
            }
        }

        // Draw Settings Table
        echo '<form method="post" action=""><table class="form-table" role="presentation">';

        // Draw Social Media Buttons Order Field
        $max_buttons = 5;
        $count = 0;
        $draw_field = '';
        while ($count != $max_buttons) {
            $count++;
            $field_value = get_option('ysp-smb-button-'.$count.'-type');
            $draw_field .= '<p>';
            $draw_field .= '<strong class="sub-label">'.__('Button', 'ysdb-socialbtns').' '.$count.'</strong>';
            $draw_field .= '<select title="'.__('Social Media Button Order', 'ysdb-socialbtns').'" name="ysp-smb-button-'.$count.'-type">';
            $draw_field .= '<option '.(($field_value=='none')?'selected="selected"':"").' value="none">'.__('** Hide Button **', 'ysdb-socialbtns').'</option>';
            $draw_field .= '<option '.(($field_value=='twitter')?'selected="selected"':"").' value="twitter">'.__('Twitter', 'ysdb-socialbtns').'</option>';
            $draw_field .= '<option '.(($field_value=='facebook')?'selected="selected"':"").' value="facebook">'.__('Facebook', 'ysdb-socialbtns').'</option>';
            $draw_field .= '<option '.(($field_value=='linkedin')?'selected="selected"':"").' value="linkedin">'.__('LinkedIn', 'ysdb-socialbtns').'</option>';
            $draw_field .= '<option '.(($field_value=='email')?'selected="selected"':"").' value="email">'.__('Email', 'ysdb-socialbtns').'</option>';
            $draw_field .= '<option '.(($field_value=='whatsapp')?'selected="selected"':"").' value="whatsapp">'.__('Whatsapp', 'ysdb-socialbtns').'</option>';
            $draw_field .= '</select>';
            $draw_field .= '</p>';
        }
        echo '
        <tr>
            <th><label>'.__('Social Media Buttons', 'ysdb-socialbtns').'</label></th>
            <td>'.$draw_field.'</td>
        </tr>';

        // Close Settings Table
        echo '</table><input class="button button-primary" type="submit" value="'. __('Save Changes'). '" /></form>';

        // Draw Settings Page Footer
        echo '
        </div>
        ';
    }
	
}

$wpysdbsocialbtns = new wpysdbsocialbtns();

function ysp_socialbtns($share_title = TRUE, $post_id = '', $post_title = '', $twitter_hashtag = '', $echo = TRUE) {
    $output = '';

	$output .= '<div class="c-social-share">';
	
	if ($share_title == TRUE) {
        $output.= '<div class="c-social-share--title">' . __('Share this page:', 'ysdb-socialbtns') . '</div>';

        $title = $post_title;
        if (!empty($post_id)) {
            $permalink = urldecode(get_the_permalink($post_id));
        } else {
            $permalink = urldecode((isset($_SERVER['HTTPS']) && $_SERVER['HTTPS'] === 'on' ? "https" : "http") . "://$_SERVER[HTTP_HOST]$_SERVER[REQUEST_URI]");
        }

        $max_buttons = 5;
        $count = 0;
        $customicon = ""; // TODO

        while ($count != $max_buttons) {
            $count++;
            $field_value = get_option('ysp-smb-button-'.$count.'-type');

            switch ($field_value) {
                case 'twitter':
                    $output.= '
                        <div class="c-social-share--share-link share-twitter">
                            <a target="_blank" title="'.__('Share with Twitter', 'ysdb-socialbtns').'" href="http://twitter.com/share?text='.urlencode($title.' '.$twitter_hashtag).'&url='.$permalink.'">
                                <i class="'.($customicon ? $customicon : 'fab fa-twitter').'"></i>
                                <span> Twitter</span>
                            </a>
                        </div>';
                    break;

                case 'facebook':
                    $output.= '
                        <div class="c-social-share--share-link share-facebook">
                            <a target="_blank" title="'.__('Share with Facebook', 'ysdb-socialbtns').'" href="http://www.facebook.com/sharer.php?u='.$permalink.'&t='.urlencode($title).'">
                                <i class="'.($customicon ? $customicon : 'fab fa-facebook-f').'"></i>
                                <span> Facebook</span>
                            </a>
                        </div>';
                    break;

                case 'linkedin':
                    $output.= '
                        <div class="c-social-share--share-link share-linkedin">
                            <a target="_blank" title="'.__('Share with LinkedIn', 'ysdb-socialbtns').'" href="https://www.linkedin.com/shareArticle?mini=true&url='.$permalink.'&title='.urlencode($title).'">
                                <i class="'.($customicon ? $customicon : 'fab fa-linkedin-in').'"></i>
                                <span> LinkedIn</span></a>
                        </div>';
                    break;

                case 'whatsapp':
                    $output.= '
                        <div class="c-social-share--share-link d-md-none share-whatsapp">
                            <a target="_blank" title="'.__('Share with Whatsapp', 'ysdb-socialbtns').'" href="https://api.whatsapp.com/send?text='.urlencode($title).'%20'.$permalink.'">
                                <i class="'.($customicon ? $customicon : 'fab fa-whatsapp').'"></i>
                                <span> Whatsapp</span>
                            </a>
                        </div>';
                    break;

                case 'email':
                    $output.= '
                        <div class="c-social-share--share-link share-e-mail">
                            <a target="_blank" title="'.__('Share with Email', 'ysdb-socialbtns').'" href="mailto:?subject='.urlencode($title).'&body='.$permalink.'">
                                <i class="'.($customicon ? $customicon : 'far fa-envelope').'"></i>
                                <span> E-mail</span>
                            </a>
                        </div>';
                    
                default:
                    // HIDE BUTTON OR UNSUPPORTED VALUE WHICH ALSO MEANS HIDE BUTTON
                    break;
            }
        }
        
	}

	$output.= '</div>';
	
	if ($echo == TRUE) {
	    echo $output;
	} else {
	    return $output;
	}
}

// Add Shortcode
function ysp_socialbtns_sc($atts) {

	// Attributes
	$atts = shortcode_atts(
		array(
			'share_title' => 1,
			'post_id' => '',
			'post_title' => '',
			'twitter_hashtag' => '',
		),
		$atts
	);
	
	if (is_single()) {
	    $atts['post_id'] = get_the_ID();
	    $atts['post_title'] = get_the_title();
	}
	return ysp_socialbtns($atts['share_title'], $atts['post_id'], $atts['post_title'], $atts['twitter_hashtag'], FALSE);

}
add_shortcode( 'ysp_socialbtns', 'ysp_socialbtns_sc' );